CoreUI ONE — 250+ PRO components and 25+ admin templates for React, Angular, Vue, Bootstrap and Next.js, plus Data Grid, Scheduler, 4,300+ PRO icons and the Next.js boilerplate. One license. → See what you get

How to handle radio buttons in Vue

Handling radio button inputs is crucial for creating single-selection forms, preference settings, and option choosers in Vue applications. As the creator of CoreUI, a widely used open-source UI library, I’ve implemented radio button controls in hundreds of Vue components. From my expertise, the most reliable approach is using the v-model directive with the same model property across all radio buttons in a group. This ensures only one option can be selected at a time while maintaining reactive data binding.

Use v-model with the same property across radio buttons to handle single selection.

<template>
  <input type="radio" v-model="selected" value="option1" />
  <input type="radio" v-model="selected" value="option2" />
  <p>Selected: {{ selected }}</p>
</template>

<script>
export default {
  data() {
    return { selected: '' }
  }
}
</script>

Here both radio buttons share the same v-model="selected" property but have different value attributes. Vue automatically handles the single-selection logic, updating selected with the chosen option’s value. When one radio button is selected, others in the same group are automatically deselected, maintaining the expected radio button behavior.

Best Practice Note:

This is the same radio button handling pattern we use in CoreUI Vue components for configuration forms and user preferences. Always provide meaningful value attributes and consider setting a default selection to improve user experience in forms.


Speed up your responsive apps and websites with fully-featured, ready-to-use open-source admin panel templates—free to use and built for efficiency.


About the Author

Subscribe to our newsletter
Get early information about new products, product updates and blog posts.

CoreUI ONE — 250+ PRO components and 25+ admin templates for React, Angular, Vue, Bootstrap and Next.js, plus Data Grid, Scheduler, 4,300+ PRO icons and the Next.js boilerplate. One license. → See what you get

How to handle radio buttons in React

Handling radio buttons in React requires controlled components where React manages the selected state through component state and event handlers. As the creator of CoreUI, a widely used open-source UI library, I’ve implemented radio button controls in thousands of React forms for enterprise applications. From my expertise, the most effective approach is using controlled components with shared name attributes and value checking. This method provides predictable form behavior with proper state management and validation.

Use controlled components with checked property and onChange handler for radio button groups.

import { useState } from 'react'

function RadioForm() {
  let [selectedOption, setSelectedOption] = useState('')

  return (
    <form>
      <label>
        <input
          type="radio"
          name="options"
          value="option1"
          checked={selectedOption === 'option1'}
          onChange={(e) => setSelectedOption(e.target.value)}
        />
        Option 1
      </label>

      <label>
        <input
          type="radio"
          name="options"
          value="option2"
          checked={selectedOption === 'option2'}
          onChange={(e) => setSelectedOption(e.target.value)}
        />
        Option 2
      </label>
    </form>
  )
}

Radio buttons in the same group share the same name attribute. Use checked property to control which radio is selected by comparing the current state with the input’s value. The onChange handler updates state when users select different options.

Best Practice Note:

This is the same radio button approach we use in CoreUI React components for form controls. Always use controlled components and provide default values for better user experience and form validation.


Speed up your responsive apps and websites with fully-featured, ready-to-use open-source admin panel templates—free to use and built for efficiency.


About the Author

Subscribe to our newsletter
Get early information about new products, product updates and blog posts.
Black Friday aka Black Week aka Bull Shit?
Black Friday aka Black Week aka Bull Shit?

React? We’ve got (no) problem. Top5 React issues.
React? We’ve got (no) problem. Top5 React issues.

CoreUI & Vue.js Forge… cause 1 is just not enough!
CoreUI & Vue.js Forge… cause 1 is just not enough!

Vue.js Forge
Vue.js Forge